unit try_threads_unit1;

INTERFACE

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, try_threads_unit2, ExtCtrls;

type
  TThreadForm = class(TForm)
    SzamolButton: TBitBtn;
    CloseButton: TBitBtn;
    GroupBox1: TGroupBox;
    ThreadXLabel: TLabel;
    Label1: TLabel;
    EditX: TEdit;
    Label2: TLabel;
    ComboBox1: TComboBox;
    GroupBox2: TGroupBox;
    ThreadYLabel: TLabel;
    Label3: TLabel;
    EditY: TEdit;
    Label4: TLabel;
    ComboBox2: TComboBox;
    Image1: TImage;
    Image2: TImage;
    procedure SzamolButtonClick(Sender: TObject);
  private
    { Private declarations }
    ThreadX, ThreadY: TSzamoloThread;
    ThreadsRunning: Integer;
    procedure ThreadDone(Sender: TObject);
    function  GetPriority(ComboBoxIndex: Integer): TThreadPriority;
  public
    { Public declarations }
  end;

var
  ThreadForm: TThreadForm;

IMPLEMENTATION

{$R *.DFM}

procedure TThreadForm.SzamolButtonClick(Sender: TObject);
begin
  SzamolButton.Enabled:=False;
  CloseButton.Enabled:=False;
  Image1.Visible:=False;
  Image2.Visible:=False;
  if (StrToInt(EditX.Text) > 32767) or (StrToInt(EditX.Text) < 100)
  then EditX.Text:='10000';
  if (StrToInt(EditY.Text) > 32767) or (StrToInt(EditY.Text) < 100)
  then EditY.Text:='10000';
  ThreadX:=TSzamoloThreadX.Create(ThreadXLabel, StrToInt(EditX.Text));
  if ComboBox1.Itemindex <> -1
  then ThreadX.Priority:=GetPriority(ComboBox1.Itemindex)
  else ThreadX.Priority:=tpNormal;
  ThreadY:=TSzamoloThreadY.Create(ThreadYLabel, StrToInt(EditY.Text));
  if ComboBox2.Itemindex <> -1
  then ThreadY.Priority:=GetPriority(ComboBox2.Itemindex)
  else ThreadY.Priority:=tpHigher;
  ThreadX.OnTerminate:=ThreadDone;
  ThreadY.OnTerminate:=ThreadDone;
  ThreadsRunning:=2;
end;

procedure TThreadForm.ThreadDone(Sender: TObject);
begin
  Dec(ThreadsRunning);
  MessageBeep(1);
  if Sender = ThreadX then Image1.Visible:=True;
  if Sender = ThreadY then Image2.Visible:=True;
  if ThreadsRunning = 0 then
  begin
    SzamolButton.Enabled:=True;
    CloseButton.Enabled:=True;
  end;
end;

function  TThreadForm.GetPriority(ComboBoxIndex: Integer): TThreadPriority;
begin
  case ComboBoxIndex of
    -1: GetPriority:=tpNormal;
     0: GetPriority:=tpIdle;
     1: GetPriority:=tpLowest;
     2: GetPriority:=tpLower;
     3: GetPriority:=tpNormal;
     4: GetPriority:=tpHigher;
     5: GetPriority:=tpHighest;
     6: GetPriority:=tpTimeCritical;
     else GetPriority:=tpNormal;
  end;
end;

END.
