unit try_threads_unit2;

INTERFACE

uses
  Classes, StdCtrls, SysUtils;

type
  TSzamoloThread = class(TThread)
  private
    { Private declarations }
    Ertek: Integer;
    Probak, Szam: Double;
    UseLabel: TLabel;
    MaxCount: Integer;
  protected
    procedure Execute; override;
    procedure szamol; virtual; abstract;
    procedure kiir;
  public
    constructor Create(ALabel: TLabel; AMax: Integer);
  end;

  TSzamoloThreadX = class(TSzamoloThread)
  protected
    procedure szamol; override;
  end;

  TSzamoloThreadY = class(TSzamoloThread)
  protected
    procedure szamol; override;
  end;


IMPLEMENTATION

{ Important: Methods and properties of objects in VCL can only be used in a
  method called using Synchronize, for example,

      Synchronize(UpdateCaption);

  and UpdateCaption could look like,

    procedure TSzamoloThread.UpdateCaption;
    begin
      Form1.Caption := 'Updated in a thread';
    end; }

{ TSzamoloThread }

constructor TSzamoloThread.Create(ALabel: TLabel; AMax: Integer);
begin
  Inherited Create(False); {Hogy a Create() utn rgtn elinduljon.}
  UseLabel:=ALabel;
  MaxCount:=AMax;
  Szam:=0;
end;

procedure TSzamoloThread.Execute;
begin
  Szamol;
end;

procedure TSzamoloThread.Kiir;
begin
  UseLabel.Caption:='ciklus i: '+IntToStr(Ertek)+ ' tlag prbk: '+
    FloatToStr(Probak)+ ' Szm: '+FloatToStr(Szam);
end;

procedure TSzamoloThreadX.Szamol;
var
  i, r: Integer;
  LProbak: Longint;
begin
  Randomize;
  for i:=1 to MaxCount do
  begin
    r:=Random(MaxCount-i);
    repeat
      Inc(LProbak);
    until r = Random(MaxCount-i);
    Probak:=(Probak*(i-1)+LProbak)/i;
    Inc(Ertek);
    Szam:=Szam+r;
    Synchronize(Kiir);
  end;
end;

procedure TSzamoloThreadY.Szamol;
var
  i, r: Integer;
  LProbak: Longint;
begin
  Randomize;
  for i:=1 to MaxCount do
  begin
    r:=Random(i);
    LProbak:=0;
    repeat
      Inc(LProbak);
    until r = Random(i);
    Probak:=(Probak*(i-1)+LProbak)/i;
    Inc(Ertek);
    Szam:=Szam+r;
    Synchronize(Kiir);
  end;
end;


END.
